/* Copyright (c) 2011, The Tor Project, Inc. */
/* See LICENSE for licensing information */

#ifndef UPDATERDIALOG_H
#define UPDATERDIALOG_H

#include <QtGui>

#include "ui/ui_maindialog.h"
#include "ThandyWrapper.h"

class DownloadWidget;

class UpdaterDialog : public QDialog
{
 Q_OBJECT

 public:
  /** Possible displayed pages from the main StackedWidget */
  enum Pages { pgProcess = 0, pgUpdate };
  /** Message types from Thandy's output */
  enum MsgType { INFO = 0, ERROR, DOWNLOAD, READY, 
                 WANTFILE, WAIT, ALREADY };

  /** Default constructor */
  UpdaterDialog(ThandyWrapper *th, 
                const QString &restartCmd = QString(), 
                QWidget *parent = 0);
  /** Destructor */
  ~UpdaterDialog();

 protected:
  /** CloseEvent reimplement to avoid closing the application while it
      is in the middle of an update */
  virtual void closeEvent(QCloseEvent *ev);

 private:
  /** Autogenerated Ui */
  Ui::UpdaterDialog ui;
  /** Thandy wrapper for updates and checks */
  ThandyWrapper *thandy;
  /** Boolean value, true if it's in the middle of an update */
  bool updating;
  /** Layout to handle the message output and the download progress
      bars */
  QVBoxLayout *statusLayout, *downloadLayout;
  /** Hash to handle files being downloaded and their graphical
      representation */
  QHash<QString, DownloadWidget *> downloadHash;
  /** Pointer to the last message added */
  QLabel *lastLabel;
  /** Command to be executed after everything has finished */
  QString restartCmd;

  /** Returns true if there is at least one of the main process
      running (Tor, Vidalia or Firefox) */
  bool isSomethingRunning();
  /** Starts the update process */
  void startUpdate();
  /** Processes one output message from the Thandy wrapper */
  const QString processMessage(const QString &msg);
  /** Parses one output message from the Thandy wrapper */
  const QPair<MsgType, QStringList> parseMessage(const QString &str);

  /** Adds a status message to the GUI */
  void addStatus(const QString &msg);
  /** Adds a new download graphical representation to the GUI */
  void addDownload(const QString &name, int size, int downloaded);

 private slots:
  /** Slot wrapper to processMessage */
  void displayMessage(const QString &msg);
  /** Slot for the done() signal from the Thandy wrapper */
  void done();
};

#endif
